// Copyright (C) 2005-2006 Code Synthesis Tools CC
//
// This program was generated by XML Schema Definition Compiler (XSD)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// In addition, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

#ifndef HELLO_HXX
#define HELLO_HXX

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/pre.hxx>

#ifndef XSD_USE_CHAR
#define XSD_USE_CHAR
#endif

#ifndef XSD_CXX_PARSER_USE_CHAR
#define XSD_CXX_PARSER_USE_CHAR
#endif

#include <xsd/cxx/parser/exceptions.hxx>
#include <xsd/cxx/parser/xerces/elements.hxx>
#include <xsd/cxx/parser/types.hxx>

namespace xml_schema
{
  // Generic parser.
  //
  #ifndef XSD_CXX_PARSER_XERCES_CHAR_PARSER_IN___XML_SCHEMA
  #define XSD_CXX_PARSER_XERCES_CHAR_PARSER_IN___XML_SCHEMA

  template <typename X>
  struct parser: ::xsd::cxx::parser::xerces::traverser< X, char >
  {
  };

  #endif


  // Parsers for XML Schema built-in types.
  //

  // 8-bit
  //
  typedef ::xsd::cxx::parser::byte< char, ::xsd::cxx::parser::xerces::traverser > byte;
  typedef ::xsd::cxx::parser::unsigned_byte< char, ::xsd::cxx::parser::xerces::traverser > unsigned_byte;

  // 16-bit
  //
  typedef ::xsd::cxx::parser::short_< char, ::xsd::cxx::parser::xerces::traverser > short_;
  typedef ::xsd::cxx::parser::unsigned_short< char, ::xsd::cxx::parser::xerces::traverser > unsigned_short;

  // 32-bit
  //
  typedef ::xsd::cxx::parser::int_< char, ::xsd::cxx::parser::xerces::traverser > int_;
  typedef ::xsd::cxx::parser::unsigned_int< char, ::xsd::cxx::parser::xerces::traverser > unsigned_int;

  // 64-bit
  //
  typedef ::xsd::cxx::parser::long_< char, ::xsd::cxx::parser::xerces::traverser > long_;
  typedef ::xsd::cxx::parser::unsigned_long< char, ::xsd::cxx::parser::xerces::traverser > unsigned_long;

  // Boolean.
  //
  typedef ::xsd::cxx::parser::boolean< char, ::xsd::cxx::parser::xerces::traverser > boolean;

  // Floating-point types.
  //
  typedef ::xsd::cxx::parser::float_< char, ::xsd::cxx::parser::xerces::traverser > float_;
  typedef ::xsd::cxx::parser::double_< char, ::xsd::cxx::parser::xerces::traverser > double_;
  typedef ::xsd::cxx::parser::decimal< char, ::xsd::cxx::parser::xerces::traverser > decimal;

  // String.
  //
  typedef ::xsd::cxx::parser::string< char, ::xsd::cxx::parser::xerces::traverser > string;


  // Exceptions. See libxsd/xsd/cxx/parser/exceptions.hxx for details.
  //
  typedef ::xsd::cxx::parser::exception< char > exception;
  typedef ::xsd::cxx::parser::parsing< char > parsing;
  typedef ::xsd::cxx::parser::unexpected_element< char > unexpected_element;


  // Parsing flags. See libxsd/xsd/cxx/parser/elements.hxx for details.
  //
  typedef ::xsd::cxx::parser::xerces::flags flags;


  // Parsing properties. See libxsd/xsd/cxx/parser/elements.hxx for details.
  //
  typedef ::xsd::cxx::parser::xerces::properties< char > properties;
}

template < typename _xsd_hello_type, typename _xsd_greeting, typename _xsd_name >
struct hello_type: ::xsd::cxx::parser::xerces::traverser< _xsd_hello_type, char >
{
  // Parser hooks. Override them in your implementation.
  //

  virtual void
  greeting (_xsd_greeting const&);

  virtual void
  name (_xsd_name const&);

  using ::xsd::cxx::parser::xerces::traverser< _xsd_hello_type, char >::pre;
  using ::xsd::cxx::parser::xerces::traverser< _xsd_hello_type, char >::post;


  // Parser construction API.
  //

  void
  greeting (::xsd::cxx::parser::xerces::traverser< _xsd_greeting, char >&);

  void
  name (::xsd::cxx::parser::xerces::traverser< _xsd_name, char >&);

  void
  operator() (::xsd::cxx::parser::xerces::traverser< _xsd_greeting, char >&, ::xsd::cxx::parser::xerces::traverser< _xsd_name, char >&);


  // Implementation.
  //
  protected:

  virtual void
  _start_element (::std::basic_string< char > const& ns, ::std::basic_string< char > const& n);

  virtual void
  _end_element (::std::basic_string< char > const& ns, ::std::basic_string< char > const& n);

  virtual void
  _attribute (::std::basic_string< char > const& ns, ::std::basic_string< char > const& n, ::std::basic_string< char > const& v);

  private:

  ::xsd::cxx::parser::xerces::traverser< _xsd_greeting, char >* _xsd_greeting_;
  ::xsd::cxx::parser::xerces::traverser< _xsd_name, char >* _xsd_name_;
};

#include "hello.txx"

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

#endif // HELLO_HXX
